/*
  File: specifique.cpp

  (C) 2011 Philbob

  This program is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 2.1 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
//-----------------------------------------------------------------------
//	specifique.cpp
//-----------------------------------------------------------------------
#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<fftw3.h>
#include<g2.h>
#include<g2_X11.h>
//-----------------------------------------------------------------------
#define classe_e 
#include<specifique.h>
#undef classe_e

#define classe_e extern
#include<commun.h>
#undef classe_e
//-----------------------------------------------------------------------
using namespace std;
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//mini
double mini(double v1,double v2)
{
	double res;
	
	if (v1<v2)
	{
		res=v1;
	}
	else
	{
		res=v2;
	}
	
	return res;
}
//-----------------------------------------------------------------------
//maxi
double maxi(double v1,double v2)
{
	double res;
	
	if (v1>v2)
	{
		res=v1;
	}
	else
	{
		res=v2;
	}
	
	return res;
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//classe triode
//-----------------------------------------------------------------------

//constructeur
triode::triode(void)
{
	long i;		//indice de boucle
	
	strcpy(chemin,"chemin non defini");
	strcpy(nom,"triode non definie");
	
	niter=0;
	niterp=0;
	niag=0;
	vaiag=NULL;
	vgiag=NULL;
	iaiag=NULL;
	ndc=1000;
	Vgc=NULL;
	Iac=NULL;
	Vac=NULL;
	dVac=NULL;
}
//-----------------------------------------------------------------------
//destructeur
triode::~triode(void)
{
	long i;		//indice de boucle
	
	//libé memo
	if (np!=0)
	{
		free(pm);
		free(p);
	}
	
	if (nc!=0)
	{
		for (i=0;i<nc;i++)
		{
			free(Van[i]);
			free(Ian[i]);
			free(poids[i]);
		}
		
		free(Van);
		free(Ian);
		free(poids);
		free(npc);
		free(Vgn);
	}

	
	if (ndc!=0)
	{
		free(Vgc);
		free(Iac);
		free(Vac);
		free(dVac);
	}
	
	if (niag!=0)
	{
		free(vaiag);
		free(vgiag);
		free(iaiag);
	}
	
	//fermeture des fichiers
	fclose(f_dat);
	fclose(f_cfg);
	fclose(f_cmd);	
	fclose(f_tmp);	
	fclose(f_inc);	
	
}
//-----------------------------------------------------------------------
//init
void triode::init(void)
{
	char bidon[len];	//chaine bidon
	
	//recup du fichier de config du programme
	f=fopen("config.txt","r");
	verif(f,"ouverture du fichier de config prog impossible");
	
	//recup du chemin du repertoire de travail
	calage_a(f,"#chemin");
	fscanf(f,"%s",&chemin);
	printf("chemin du repertoire de travail\n");
	printf("%s\n",chemin);
	
	//recup du nom du tube
	calage_a(f,"#tube");
	fscanf(f,"%s",&nom);
	printf("tube\n");
	printf("%s\n",nom);
	
	fclose(f);
	
	
	
	//formation des noms
	strcpy(bidon,chemin);
	strcat(bidon,nom);	
	strcat(bidon,".dat");
	strcpy(tube_dat,bidon);	
	
	strcpy(bidon,chemin);
	strcat(bidon,nom);	
	strcat(bidon,".cfg");
	strcpy(tube_cfg,bidon);	
	
	strcpy(bidon,chemin);
	strcat(bidon,nom);	
	strcat(bidon,".prm");
	strcpy(tube_prm,bidon);	

	strcpy(bidon,chemin);
	strcat(bidon,nom);	
	strcat(bidon,".chg");
	strcpy(tube_chg,bidon);	

	strcpy(bidon,chemin);
	strcat(bidon,nom);	
	strcat(bidon,".mut");
	strcpy(tube_mut,bidon);	

	strcpy(bidon,chemin);
	strcat(bidon,nom);	
	strcat(bidon,".tmp");
	strcpy(tube_tmp,bidon);	

	strcpy(bidon,chemin);
	strcat(bidon,nom);	
	strcat(bidon,"_philbob");	
	strcat(bidon,".inc");
	strcpy(tube_inc,bidon);	

	strcpy(bidon,chemin);
	strcat(bidon,"cmde");
	
	f_cmd=fopen(bidon,"w");
	verif(f_cmd,"ecriture fichier cmd impossible");
	
	printf("fichiers en entree\n");	
	
	printf("fichier de config du tube\n");
	printf("%s\n",tube_cfg);
	f_cfg=fopen(tube_cfg,"r");
	verif(f_cfg,"ouverture fichier impossible");


	printf("fichier des courbes numerisees\n");
	printf("%s\n",tube_dat);
	f_dat=fopen(tube_dat,"r");
	verif(f_dat,"ouverture fichier impossible");
	
	printf("fichiers en sortie\n");	

	printf("fichier des parametres du modele\n");
	printf("%s\n",tube_prm);
	f_prm=fopen(tube_prm,"w");
	verif(f_prm,"ouverture fichier impossible");
	
	printf("fichier de la droite de charge\n");
	printf("%s\n",tube_chg);
	f_chg=fopen(tube_chg,"w");
	verif(f_chg,"ouverture fichier impossible");
	
	printf("fichier des courbes mutuelles\n");
	printf("%s\n",tube_mut);
	f_mut=fopen(tube_mut,"w");
	verif(f_mut,"ouverture fichier impossible");
	
	printf("fichier des enregistrements temporaires\n");
	printf("%s\n",tube_tmp);
	f_tmp=fopen(tube_tmp,"w");
	verif(f_tmp,"ouverture fichier impossible");
	
	printf("fichier moèle LTSpice\n");
	printf("%s\n",tube_inc);
	f_inc=fopen(tube_inc,"w");
	verif(f_inc,"ouverture fichier impossible");
	
	//lecture du fichier de config du tube
	lecture_cfg();

	//lecture du fichier des courbes numérisées
	lecture_dat();
	
	//erreur de départ
	errdeb=erreur();
}
//-----------------------------------------------------------------------
void triode::lecture_cfg(void)
{
	long i;		//indice de boucle
	
	
	printf("lecture du fichier de config du tube\n");

	//recup optimisation
	calage_a(f_cfg,"#optimise");
	fscanf(f_cfg,"%ld",&opt);
	printf("optimisation 0=non 1=oui\n");
	printf("%ld\n",opt);
	
	//recup nombre de parametres
	calage_a(f_cfg,"#nbparam");
	fscanf(f_cfg,"%ld",&np);
	printf("nombre de parametres du modele\n");
	printf("%ld\n",np);
	
	//resa memo
	pm=(double*)malloc(np*sizeof(double));
	verif(pm,"resa memo pm impossible");
	
	p=(double*)malloc(np*sizeof(double));
	verif(p,"resa memo p impossible");
	
	//lecture des parametres de depart
	calage_a(f_cfg,"#parametre");
	printf("parametres de depart\n");
	
	for (i=0;i<np;i++)
	{
		fscanf(f_cfg,"%lg",&pm[i]);
		p[i]=pm[i];
		printf("p[%ld] = %lg\n",i,p[i]);
	}
	
	//lecture droite de charge
	calage_a(f_cfg,"#charge");
	fscanf(f_cfg,"%lg",&Va0);
	fscanf(f_cfg,"%lg",&Ia0);
	fscanf(f_cfg,"%lg",&coefpoids);
	
	if (coefpoids<0)
	{
		coefpoids=0;
	}
	
	//calcul de la droite
	B=Ia0;
	A=-B/Va0;
	resist=Va0/Ia0;
	
	printf("droite de charge\n");
	printf("Va0 %lg (V)\n",Va0);
	printf("Ia0 %lg (A)\n",Ia0);
	printf("Res %lg (Ohms)\n",resist);
	
	//recup des capa parasite
	calage_a(f_cfg,"#ccg");
	fscanf(f_cfg,"%lg",&ccg);
	
	calage_a(f_cfg,"#cgp");
	fscanf(f_cfg,"%lg",&cgp);
	
	calage_a(f_cfg,"#ccp");
	fscanf(f_cfg,"%lg",&ccp);
	
	ccg=ccg*1e-12;
	cgp=cgp*1e-12;
	ccp=ccp*1e-12;

	//recup de la valeur de la resistance de grille
	calage_a(f_cfg,"#rgi");
	fscanf(f_cfg,"%lg",&Rgi);
	
	
}
//-----------------------------------------------------------------------
//chargement des courbes numérisées
void triode::lecture_dat(void)
{
	long i;				//indice de boucle
	long j;				//indice de boucle
	double spanV;		//étendue de la tension de plaque
	double spanI;		//étendue du courant de plaque
	double Ic;			//courant droite de charge
	double deltaI;		//difference de courant de plaque
	double deltanI;		//difference de courant de plaque normalisée
	double pmax;		//poids max
	double pmin;		//poids min
	
	double num;	
	char bidon[len];	//chaine bidon		
	
	printf("lecture du fichier des courbes numérisées\n");

	//recup nombre de courbes
	fscanf(f_dat,"%s",&bidon);
	fscanf(f_dat,"%s",&bidon);

	fscanf(f_dat,"%lg",&Pw_max);
	printf("puissance max de plaque (W)\n");
	printf("%lg\n",Pw_max);
	
	fscanf(f_dat,"%ld",&nc);
	printf("nombre de courbes numerisees\n");
	printf("%ld\n",nc);
	
	//resa memo
	Vgn=(double*)malloc(nc*sizeof(double));
	verif(Vgn,"resa memo Vgn impossible");
	
	npc=(long*)malloc(nc*sizeof(long));
	verif(npc,"resa memo npc impossible");
	
	Van=(double**)malloc(nc*sizeof(double*));
	verif(Van,"resa memo primaire Van impossible");
	
	Ian=(double**)malloc(nc*sizeof(double*));
	verif(Ian,"resa memo primaire Ian impossible");
	
	poids=(double**)malloc(nc*sizeof(double*));
	verif(poids,"resa memo primaire poids impossible");
	
	//recup des tensions de grille
	for (i=0;i<nc;i++)
	{
		fscanf(f_dat,"%lg",&Vgn[i]);
		printf("courbe [%ld]: Vg = %lg\n",i,Vgn[i]);
	}
		
	//recup des courbes
	for (i=0;i<nc;i++)
	{
		//recup du nombre de point par courbe
		fscanf(f_dat,"%ld",&npc[i]);
		printf("courbe [%ld]: nb points = %ld\n",i,npc[i]);
		
		Van[i]=(double*)malloc(npc[i]*sizeof(double));
		verif(Van[i],"resa memo secondaire Van impossible");
		
		Ian[i]=(double*)malloc(npc[i]*sizeof(double));
		verif(Ian[i],"resa memo secondaire Ian impossible");
		
		poids[i]=(double*)malloc(npc[i]*sizeof(double));
		verif(poids[i],"resa memo secondaire poids impossible");
		
		//recup de la courbe
		for (j=0;j<npc[i];j++)
		{
			fscanf(f_dat,"%lg",&Van[i][j]);
			fscanf(f_dat,"%lg",&Ian[i][j]);
			
			//elimination des tensions plaque <0
			
			if (Van[i][j]<0)
			{
				Van[i][j]=0;
			}
		}
	}
	
	//determination min max pour Van et Ian
	Van_max=Van[0][0];
	Van_min=Van[0][0];
	Ian_max=Ian[0][0];
	Ian_min=Ian[0][0];
	
	for (i=0;i<nc;i++)
	{
		for (j=0;j<npc[i];j++)
		{
			Van_max=maxi(Van_max,Van[i][j]);
			Van_min=mini(Van_min,Van[i][j]);
			Ian_max=maxi(Ian_max,Ian[i][j]);
			Ian_min=mini(Ian_min,Ian[i][j]);
		}
	}
	
	printf("Van max = %lg\n",Van_max);
	printf("Van min = %lg\n",Van_min);
	printf("Ian max = %lg\n",Ian_max);
	printf("Ian min = %lg\n",Ian_min);
	
	spanV=Van_max-Van_min;
	spanI=Ian_max-Ian_min;


	
	//determination des poids de pondération
	pmax=-1;
	pmin=Ian_max*Ian_max;
	
	for (i=0;i<nc;i++)
	{
		for (j=0;j<npc[i];j++)
		{
			//courant droite de charge
			Ic=A*Van[i][j]+B;
			
			//difference avec courant de courbe
			deltaI=Ian[i][j]-Ic;
			
			//normalisation
			deltanI=deltaI/spanI;
			
			//poids
			if (coefpoids==0)
			{
				poids[i][j]=1;
			}
			else
			{
				poids[i][j]=1/(deltanI*deltanI+1/coefpoids);
			}
						
			pmax=maxi(pmax,poids[i][j]);
			pmin=mini(pmin,poids[i][j]);

		}
	}
	
	printf("poids max = %lg\n",pmax);
	printf("poids min = %lg\n",pmin);
}
	
//-----------------------------------------------------------------------
//calcul de Ip le courant de plaque
double triode::Ip(double Ep,double Eg)
{
	double res;

	double E1;
	double signe;
	double v1;
	double v2;
	double v3;
	double v4;
	
	long mu;
	long expo;
	long kg1;
	long kp;
	long kvb;
	
	mu=0;
	expo=1;
	kg1=2;
	kp=3;
	kvb=4;
	
	v1=p[kvb]+Ep*Ep;
	v2=1/p[mu]+Eg/sqrt(v1);
	v3=log(1+exp(p[kp]*v2));

	E1=Ep/p[kp]*v3;
	
	if (E1>=0)
	{
		signe=1;
	}	
	else
	{
		signe=-1;
	}
	
	v4=pow(E1,p[expo])/p[kg1];
	
//	res=v4*(1+signe)/1000;
	res=v4*(1+signe)*1000;
	
	return res;
}
//-----------------------------------------------------------------------
//calcul de l'erreur
double triode::erreur(double Va,double Vg,double Ia)
{
	double res;
	double Iam;		//courant modélisé
	
	Iam=Ip(Va,Vg);
	
	res=Ia-Iam;
	
	return res;
}
//-----------------------------------------------------------------------
//calcul des erreurs
double triode::erreur(void)
{
	double res;
	
	long i;			//indice de boucle
	long j;			//indice de boucle
	double err;		//erreur
	double diff;	//difference
	double Im;		//courant modélisé

	res=0;
	
	for (i=0;i<nc;i++)
	{
		for (j=0;j<npc[i];j++)
		{
			Im=Ip(Van[i][j],Vgn[i]);
			diff=Im-Ian[i][j];
			err=diff*diff*poids[i][j];
			
			res=res+err;
		}
	}
	
	return res;
}
//-----------------------------------------------------------------------
//optimise
bool triode::optimise(double _prop)
{
	bool res;
	long i;
	long j;
	double ptmp;
	double errdeb;
	double errmin;
	double errcour;
	double sens;
	long indice;
	char bidon[len];
	
	
	//compte le nombre d'itérations
	niter++;
	niterp++;
	
	//calcul de l'erreur actuelle
	errdeb=erreur();
	
	//sauvegarde partielle
	if (niterp>=100)
	{
		
		fprintf(f_tmp,"[%ld %lg] ",niter,errdeb);
		
		for (j=0;j<np;j++)
		{
			fprintf(f_tmp,"(%ld) %lg ",j,p[j]);
		}

		fprintf(f_tmp,"\n");
		fflush(f_tmp);
		
		niterp=0;
	}
	
		
	//qui reduit le plus l'erreur
	indice=-1;
	errmin=errdeb;
	
	for (i=0;i<np;i++)
	{
		//cote +
		ptmp=p[i];
		p[i]=p[i]*(1+_prop);
		errcour=erreur();
		
		if (errcour<errmin)
		{
			errmin=errcour;
			indice=i;
			sens=1;
		}
		
		p[i]=ptmp;
		
		//cote -
		ptmp=p[i];
		p[i]=p[i]*(1-_prop);
		errcour=erreur();
		
		if (errcour<errmin)
		{
			errmin=errcour;
			indice=i;
			sens=-1;
		}
		
		p[i]=ptmp;
	}
	
	
	strcpy(bidon,"");
	
	for (i=0;i<np;i++)
	{
		if (i==indice)
		{
			if (sens>0)
			{
				strcat(bidon,"+");
			}
			else
			{
				strcat(bidon,"-");
			}
		}
		else
		{
			strcat(bidon,"0");
		}
	}
	
	
	
	printf("%s   %lg [%lg]  %lg\n",bidon,errdeb,errdeb-errmin,_prop);
	
	//deplacement suivant indice
	res=false;
	
	if (indice!=-1)
	{
		res=true;
		p[indice]=p[indice]*(1+sens*_prop);
	}
	
	return res;
}
//-----------------------------------------------------------------------
void triode::sauve_param(void)
{
	long i;
	
	//erreur à l'arrivée	fprintf(f_cmd,"pause -1\n\n");

	errfin=erreur();
	
	printf("\n");
	printf("optimisation terminée\n");
	printf("\n");

	printf("erreur initiale (somme des carrés en mA**2)\n");
	printf("%lg\n",errdeb);

	printf("erreur finale (somme des carrés en mA**2)\n");
	printf("%lg\n",errfin);
		
	printf("nombre d'itérations\n");
	printf("%ld\n",niter);
	printf("\n");

	//affichage écran
	for (i=0;i<np;i++)
	{
		printf("p[%ld] %lg ---> %lg\n",i,pm[i],p[i]);
	}

	//impression fichier
	fprintf(f_prm,"Optimisation des paramètres Norman Koren du tube %s\n",nom);
	fprintf(f_prm,"\n");
	fprintf(f_prm,"paramètres de départ\n");
	fprintf(f_prm,"#depart\n");
	
	for (i=0;i<np;i++)
	{
		fprintf(f_prm,"%lg\n",pm[i]);
	}
	
	fprintf(f_prm,"\n");
	fprintf(f_prm,"conditions d'optimisation\n");
	fprintf(f_prm,"\n");
	fprintf(f_prm,"doite de charge\n");
	fprintf(f_prm,"\n");
	fprintf(f_prm,"tension plaque max pour courant plaque nul (V)\n");
	fprintf(f_prm,"#Va0\n");
	fprintf(f_prm,"%lg\n",Va0);

	fprintf(f_prm,"\n");
	fprintf(f_prm,"courantt plaque max pour tension plaque nulle (A)\n");
	fprintf(f_prm,"#Ia0\n");
	fprintf(f_prm,"%lg\n",Ia0);

	fprintf(f_prm,"\n");
	fprintf(f_prm,"résistance de charge (Ohms)\n");
	fprintf(f_prm,"#resist\n");
	fprintf(f_prm,"%lg\n",resist);
	
	fprintf(f_prm,"\n");
	fprintf(f_prm,"coefficient de pondération de la droite de charge\n");
	fprintf(f_prm,"#coef\n");
	fprintf(f_prm,"%lg\n",coefpoids);
	
	fprintf(f_prm,"\n");
	fprintf(f_prm,"somme des carrés des écarts du modèle aux paramètres initiaux (mA**2)\n");
	fprintf(f_prm,"#ecart\n");
	fprintf(f_prm,"%lg\n",errdeb);

	fprintf(f_prm,"\n");
	fprintf(f_prm,"nombre d'itérations\n");
	fprintf(f_prm,"%ld\n",niter);

	fprintf(f_prm,"\n");
	fprintf(f_prm,"somme des carrés des écarts du modèle aux paramètres optimisés (mA**2)\n");
	fprintf(f_prm,"#ecart\n");
	fprintf(f_prm,"%lg\n",errfin);

	fprintf(f_prm,"\n");
	fprintf(f_prm,"paramètres optimisés\n");
	fprintf(f_prm,"#optimise\n");
	
	for (i=0;i<np;i++)
	{
		fprintf(f_prm,"%lg\n",p[i]);
	}
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
//courbe mutuelle
void triode::mutuelle(void)
{
	long i;				//indice de boucle
	double Vg;			//tension de grille
	double Vgmin;		//tension de grille min
	double Vgmax;		//tension de grille max
	double spanVg;		//étendue de la tension de grille
	double dVg;			//variation de la tension de grille
	double Iamod;		//courant de plaque modélisé
	double Iadc;		//courant de la droite de charge
	double Va;			//tension de plaque
	double dVa;			//variation de la tension de plaque
	double mag;			//magnitude du tracé 
	double Pw;			//puissance de plaque 
	
	bool suite;			//continuation
	long j;				//compteur
	
	//init
	
	//calcul de Vg min et max
	Vgmin=Vgn[0];
	Vgmax=Vgn[0];
	
	for (i=0;i<nc;i++)
	{
		Vgmin=mini(Vgmin,Vgn[i]);
		Vgmax=maxi(Vgmax,Vgn[i]);
	}

	//calcul de spanVg et dVg
	spanVg=Vgmax-Vgmin;
	dVg=spanVg/(ndc-1);
	
	printf("Vgmax Vgmin %lg %lg\n",Vgmax,Vgmin);

	//resa memo
	Vgc=(double*)malloc(ndc*sizeof(double));
	verif(Vgc,"malloc Vgc impossible");

	Iac=(double*)malloc(ndc*sizeof(double));
	verif(Iac,"malloc Iac impossible");
		
	Vac=(double*)malloc(ndc*sizeof(double));
	verif(Vac,"malloc Vac impossible");
		
	dVac=(double*)malloc(ndc*sizeof(double));
	verif(dVac,"malloc dVac impossible");

	
	//détermination de Vg le long de la droite de charge

	printf("tracé de la caracteristique mutuelle\n");

	dVa=1;
	i=0;
	
	for (Vg=Vgmax-dVg;Vg>=Vgmin;Vg=Vg-dVg)
	{
		//calcul de l'intersection de la courbe du tube pour Vg avec la droite de charge
		suite=true;
		Va=0;
		
		while (suite==true)
		{
			Iamod=Ip(Va,Vg);
			Iadc=(A*Va+B)*1000;
			
			//y a t'il croisement des courbes ?
			if (Iamod>=Iadc)
			{
				//oui, donc stop
				suite=false;
			}
			else
			{
				//non donc on incrémente Va
				Va=Va+dVa;
			}
		}
		
		//à ce stade, le point d'intersection est compris entre Va-dVa et Va
		//affinage
		Va=dicho(Vg,Va-dVa,Va);
		
		//stockage du point
		Vgc[i]=Vg;
		Vac[i]=Va;
		Iac[i]=Ip(Va,Vg);
		i++;
	}
	
	//calcul de la dérivée

	printf("tracé de la dérivée\n");
	
	i=0;
	dVac[i]=(Vac[i+1]-Vac[i])/(Vgc[i+1]-Vgc[i]);
	
	for (i=1;i<ndc-1;i++)
	{
		dVac[i]=(Vac[i+1]-Vac[i-1])/(Vgc[i+1]-Vgc[i-1]);
	}

	i=ndc-1;
	dVac[i]=(Vac[i]-Vac[i-1])/(Vgc[i]-Vgc[i-1]);
	
	//ecriture
	gain_max=0;
	polar=0;
	
	for (i=0;i<ndc-2;i++)
	{
		fprintf(f_chg,"%lg %lg %lg %lg\n",Vgc[i],Iac[i],Vac[i],dVac[i]);
		
		//recherche gain max et polar idéale
		if (-dVac[i]>gain_max)
		{
			gain_max=-dVac[i];
			polar=Vgc[i];
		}
	}
	
	printf("gain max %lg pour polar à %lg (V)\n",gain_max,polar);
	
	//courbes mutuelles
	mag=pow(10,(long)(log10(Van_max)));
	dVa=mag/2;
	
	for (Va=dVa;Va<=Va0;Va=Va+dVa)
	{
		niag++;
		vaiag=(double*)realloc(vaiag,niag*sizeof(double));
		verif(vaiag,"realloc vaiag impossible");
		vgiag=(double*)realloc(vgiag,niag*sizeof(double));
		verif(vgiag,"realloc vgiag impossible");
		iaiag=(double*)realloc(iaiag,niag*sizeof(double));
		verif(iaiag,"realloc iaiag impossible");
		j=0;
	
		for (Vg=Vgmax;Vg>Vgmin;Vg=Vg-dVg)
		{
			Iamod=Ip(Va,Vg);
			
			//limitation au courant max de plaque des courbes numérisées
			//et à la Pw max
			Pw=Iamod/1000*Va;
			
			if (Iamod<=Ian_max && Pw<=Pw_max)
			{
				if (j==0)
				{
					vaiag[niag-1]=Va;
					vgiag[niag-1]=Vg;
					iaiag[niag-1]=Iamod;
				}
				
				fprintf(f_mut,"%lg %lg %lg\n",Va,Vg,Iamod);
				j++;
			}
		}

		fprintf(f_mut,"\n");	
	}

	fclose(f_prm);
	fclose(f_chg);	
	fclose(f_mut);	
}
//-----------------------------------------------------------------------
//tracé courbes
void triode::trace(void)
{
	long i;					//indice de boucle
	long j;					//indice de boucle
	char bidon[len];		//chaine
	char titre[len];		//chaine
	double ia;				//courant de plaque
	double va;				//tension de plaque
	

	//tracé image 1 *******************************************************
	
	fprintf(f_cmd,"reset\n");
	fprintf(f_cmd,"set term wxt 0 persist\n");
	fprintf(f_cmd,"set title \"Comparaison Numérisation - Modélisation\"\n");
	fprintf(f_cmd,"set xlabel \"Va (V)\"\n");
	fprintf(f_cmd,"set ylabel \"Ia (mA)\"\n");
	fprintf(f_cmd,"set grid\n");
	fprintf(f_cmd,"set xrange[0:]\n");
	fprintf(f_cmd,"set yrange[0:]\n");

	//labels
	for (i=0;i<nc;i++)
	{
		fprintf(f_cmd,"set label \"%lg\" at %lg,%lg\n",Vgn[i],Van[i][npc[i]-1],Ian[i][npc[i]-1]);
	}

	fprintf(f_cmd,"set label \"R=%lg (Ohms)\" at %lg,%lg\n",resist,0.0,Ia0*1000);

	//trace reseau num
	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,"_num.gnu");
	
	strcpy(titre,nom);
	strcat(titre," numerisé");
	
	fprintf(f_cmd,"plot \"%s\" using 1:3 with line title \"%s\"\n",bidon,titre);
	
	f=fopen(bidon,"w");
	verif(f,"ecriture fichier impossible");
	
	for (i=0;i<nc;i++)
	{
		for (j=0;j<npc[i];j++)
		{
			fprintf(f,"%lg %lg %lg\n",Van[i][j],Vgn[i],Ian[i][j]);
		}
		
		fprintf(f,"\n");
	}
	
	fclose(f);
	
	//trace reseau modélisé
	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,"_mod.gnu");

	strcpy(titre,nom);
	strcat(titre," modélisé");
	
	fprintf(f_cmd,"replot \"%s\" using 1:3 with line title \"%s\"\n",bidon,titre);
	
	f=fopen(bidon,"w");
	verif(f,"ecriture fichier impossible");
	
	for (i=0;i<nc;i++)
	{
		for (j=0;j<npc[i];j++)
		{
			fprintf(f,"%lg %lg %lg\n",Van[i][j],Vgn[i],Ip(Van[i][j],Vgn[i]));
		}
		
		fprintf(f,"\n");
	}
	
	fclose(f);	

	//tracé de la courbe pmax
	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,"_pwm.gnu");

	strcpy(titre,nom);
	strcat(titre," Pw max");
	
	fprintf(f_cmd,"replot \"%s\" using 1:2 with line title \"%s\"\n",bidon,titre);
	
	f=fopen(bidon,"w");
	verif(f,"ecriture fichier impossible");
	
	for (va=1;va<=Van_max;va++)
	{
		ia=Pw_max/va*1000;
		
		if (ia<=Ian_max)
		{
			fprintf(f,"%lg %lg\n",va,ia);
		}
	}
	
	fclose(f);	
	
	//tracé de la droite de charge
	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,"_chg.gnu");

	strcpy(titre,nom);
	strcat(titre," DDC");
	
	fprintf(f_cmd,"replot \"%s\" using 1:2 with line title \"%s\"\n",bidon,titre);
	
	f=fopen(bidon,"w");
	verif(f,"ecriture fichier impossible");
	
	for (va=0;va<=Van_max;va++)
	{
		ia=(A*va+B)*1000;
		
		//limitation ia>=0
		if (ia>=0)
		{
			fprintf(f,"%lg %lg\n",va,ia);
		}
	}


	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,"_carac1.png");

	fprintf(f_cmd,"set term png size 1500,1200\n");
	fprintf(f_cmd,"set output \"%s\"\n",bidon);
	fprintf(f_cmd,"replot\n");



	//tracé image 2 *******************************************************

	//tracé de la surface des ecarts
	fprintf(f_cmd,"reset\n");
	fprintf(f_cmd,"set term wxt 1 persist\n");
	fprintf(f_cmd,"set title \"Ecarts Numérisation-Modélisation\"\n");
	fprintf(f_cmd,"set xlabel \"Va (V)\"\n");
	fprintf(f_cmd,"set ylabel \"Ia (mA)\"\n");
	fprintf(f_cmd,"set zlabel \"Ianum-Iamod (mA)\" rotate by 90\n");
	fprintf(f_cmd,"set grid\n");



	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,"_err.gnu");

	strcpy(titre,nom);
	strcat(titre," ecarts");
	
	fprintf(f_cmd,"splot \"%s\" using 1:2:3 with line title \"%s\"\n",bidon,titre);
	
	f=fopen(bidon,"w");
	verif(f,"ecriture fichier impossible");
	
	//tracé
	for (i=0;i<nc;i++)
	{
		for (j=0;j<npc[i];j++)
		{
			fprintf(f,"%lg %lg %lg\n",Van[i][j],Ian[i][j],Ian[i][j]-Ip(Van[i][j],Vgn[i]));
		}
		
		fprintf(f,"\n");
	}

	fclose(f);	
	
	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,"_carac2.png");

	fprintf(f_cmd,"set term png size 1500,1200\n");
	fprintf(f_cmd,"set output \"%s\"\n",bidon);
	fprintf(f_cmd,"replot\n");

	//tracé image 3 *******************************************************
	
	fprintf(f_cmd,"reset\n");
	fprintf(f_cmd,"set term wxt 2 persist\n");
	fprintf(f_cmd,"set title \"réseau Ia=f(Vg) à Va cste et Ia=f(Vg) le long de la DDC\"\n");
	fprintf(f_cmd,"set xlabel \"Vg (V)\"\n");
	fprintf(f_cmd,"set ylabel \"Ia (mA)\"\n");
	fprintf(f_cmd,"set grid\n");
	fprintf(f_cmd,"set xrange[:0]\n");
	fprintf(f_cmd,"set yrange[0:]\n");

	for (i=0;i<niag;i++)
	{
		fprintf(f_cmd,"set label \"%lg\" at %lg,%lg\n",vaiag[i],vgiag[i],iaiag[i]);
	}


	//tracé
	//tracé
	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,".mut");

	fprintf(f_cmd,"plot \"%s\" using 2:3 with line title \"Ia=f(Vg)\"\n",bidon);

	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,".chg");

	fprintf(f_cmd,"replot \"%s\" using 1:2 with line title \"Ia=f(Vg) sur DDC\"\n",bidon);

	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,"_carac3.png");

	fprintf(f_cmd,"set term png size 1500,1200\n");
	fprintf(f_cmd,"set output \"%s\"\n",bidon);
	fprintf(f_cmd,"replot\n");

	//tracé image 4 *******************************************************
	
	fprintf(f_cmd,"reset\n");
	fprintf(f_cmd,"set term wxt 3 persist\n");
	fprintf(f_cmd,"set title \"dVa/dVg le long de la DDC\"\n");
	fprintf(f_cmd,"set xlabel \"Vg (V) [gain max=%lg pour Vg=%lg V]\"\n",gain_max,polar);
	fprintf(f_cmd,"set ylabel \"dVa (V/V)\"\n");
	fprintf(f_cmd,"set grid\n");
	fprintf(f_cmd,"set xrange[:0]\n");
	fprintf(f_cmd,"set yrange[:0]\n");


	//tracé
	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,".chg");

	fprintf(f_cmd,"plot \"%s\" using 1:4 with line title \"dVa/dVg\"\n",bidon);

	strcpy(bidon,chemin);
	strcat(bidon,nom);
	strcat(bidon,"_carac4.png");

	fprintf(f_cmd,"set term png size 1500,1200\n");
	fprintf(f_cmd,"set output \"%s\"\n",bidon);
	fprintf(f_cmd,"replot\n");



}
//-----------------------------------------------------------------------
//opti
bool triode::opti(void)
{
	bool res;
	
	if (opt==1)
	{
		res=true;
	}
	else
	{
		res=false;
	}
	
	return res;
}
//-----------------------------------------------------------------------
//dichotomie
double triode::dicho(double vg,double va1,double va2)
{
	double C;		//pente de la corde
	double D;		//ordo de la corde
	double ia1;		//courant plaque pour va1
	double ia2;		//courant plaque pour va2
	double delta;	//determinant
	double vac;		//tension de plaque courante
	double iamod;	//courant de plaque modelisé
	double iadc;	//courant droite de charge
	double seuil;	//seuil d'arret
	bool suite;		//continuation
	double ecart;	//ecart des courants
	
	suite=true;
	seuil=1e-6;
	
	while (suite==true)
	{
		//determination de la corde
		ia1=Ip(va1,vg);
		ia2=Ip(va2,vg);
	
		delta=va1-va2;
		C=(ia1-ia2)/delta;
		D=(va1*ia2-va2*ia1)/delta;
	
		//calcul de l'intersection
		vac=(D-B*1000)/(A*1000-C);
		
		//calcul des courants
		iamod=Ip(vac,vg);
		iadc=(A*vac+B)*1000;

		//calcul ecart
		ecart=iadc-iamod;

		//continuation ?
		if (fabs(ecart)<seuil)
		{
			//non donc stop
			suite=false;
		}	
		else
		{
			//oui donc deplacement
			
			if (ecart>0)
			{
				va1=vac;
			}
			else
			{
				va2=vac;
			}
		}
	}	

	return vac;
}
//-----------------------------------------------------------------------
//fichier LTSpice
void triode::LTSpice(void)
{
	char bidon[len];		//chaine
	
	fprintf(f_inc,"*-------------------------------------------------------------------------------------\n");
	fprintf(f_inc,"*     %s    [modele Norman Koren parametres philbob]\n",nom);
	fprintf(f_inc,"*-------------------------------------------------------------------------------------\n");
	fprintf(f_inc,".subckt %s_philbob 1 2 3;(anode grille cathode)\n",nom);
	fprintf(f_inc,"+ params:\n");
	fprintf(f_inc,"+ mu  = %lg\n",p[0]);
	fprintf(f_inc,"+ ex  = %lg\n",p[1]);
	fprintf(f_inc,"+ kg1 = %lg\n",p[2]);
	fprintf(f_inc,"+ kp  = %lg\n",p[3]);
	fprintf(f_inc,"+ kvb = %lg\n",p[4]);
	fprintf(f_inc,"+ ccg = %lg\n",ccg);
	fprintf(f_inc,"+ cgp = %lg\n",cgp);
	fprintf(f_inc,"+ ccp = %lg\n",ccp);
	fprintf(f_inc,"e1 7 0 value=\n");
	fprintf(f_inc,"+{v(1,3)/kp*log(1+exp(kp*(1/mu+v(2,3)/sqrt(kvb+v(1,3)*v(1,3)))))}\n");
	fprintf(f_inc,"re1 7 0 1g\n");
	fprintf(f_inc,"g1 1 3 value= {(pwr(v(7),ex)+pwrs(v(7),ex))/kg1}\n");
	fprintf(f_inc,"rcp 1 3 1g\n");
	fprintf(f_inc,"c1 2 3 {ccg}\n");
	fprintf(f_inc,"c2 1 2 {cgp}\n");
	fprintf(f_inc,"c3 1 3 {ccp}\n");
	fprintf(f_inc,".ends\n");
	fprintf(f_inc,"*-------------------------------------------------------------------------------------\n");



	fprintf(f_inc,"*-------------------------------------------------------------------------------------\n");
	fprintf(f_inc,"*     %s    [modele Norman Koren parametres philbob]\n",nom);
	fprintf(f_inc,"*-------------------------------------------------------------------------------------\n");
	fprintf(f_inc,".subckt %s_philbob_D 1 2 3;(anode grille cathode)\n",nom);
	fprintf(f_inc,"+ params:\n");
	fprintf(f_inc,"+ mu  = %lg\n",p[0]);
	fprintf(f_inc,"+ ex  = %lg\n",p[1]);
	fprintf(f_inc,"+ kg1 = %lg\n",p[2]);
	fprintf(f_inc,"+ kp  = %lg\n",p[3]);
	fprintf(f_inc,"+ kvb = %lg\n",p[4]);
	fprintf(f_inc,"+ ccg = %lg\n",ccg);
	fprintf(f_inc,"+ cgp = %lg\n",cgp);
	fprintf(f_inc,"+ ccp = %lg\n",ccp);
	fprintf(f_inc,"+ rgi = %lg\n",Rgi);
	fprintf(f_inc,"e1 7 0 value=\n");
	fprintf(f_inc,"+{v(1,3)/kp*log(1+exp(kp*(1/mu+v(2,3)/sqrt(kvb+v(1,3)*v(1,3)))))}\n");
	fprintf(f_inc,"re1 7 0 1g\n");
	fprintf(f_inc,"g1 1 3 value= {(pwr(v(7),ex)+pwrs(v(7),ex))/kg1}\n");
	fprintf(f_inc,"rcp 1 3 1g\n");
	fprintf(f_inc,"c1 2 3 {ccg}\n");
	fprintf(f_inc,"c2 1 2 {cgp}\n");
	fprintf(f_inc,"c3 1 3 {ccp}\n");
	fprintf(f_inc,"r1 2 5 {rgi}\n");
	fprintf(f_inc,"d3 5 3 dx\n");
	fprintf(f_inc,".model dx d(is=1n rs=1 cjo=10pf tt=1n)\n");
	fprintf(f_inc,".ends\n");
	fprintf(f_inc,"*-------------------------------------------------------------------------------------\n");

}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------

