/*
  File: specifique.h

  (C) 2011 Philbob

  This program is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 2.1 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
//-----------------------------------------------------------------------
//	specifique.h
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------

#define classe_e extern
#include<commun.h>
#undef classe_e
//-----------------------------------------------------------------------
#ifndef specifique_h
#define specifique_h
//-----------------------------------------------------------------------
//point
struct point
{
	double x;
	double y;
};
//-----------------------------------------------------------------------
//segment
struct segment
{
	struct point pa;
	struct point pb;
	bool sel;
};
//-----------------------------------------------------------------------
//determinant
double determinant	(
						double l1c1,
						double l1c2,
						double l2c1,
						double l2c2
					);
//-----------------------------------------------------------------------
//resolution systeme 2 eq 2 inc
bool systeme_2D	(
						double l1c1,
						double l1c2,
						double l2c1,
						double l2c2,
						double sml1,
						double sml2,
						double &r1,
						double &r2
					);
//-----------------------------------------------------------------------
//calage relatif
bool calage_r(FILE *f,char mot[len]);
//-----------------------------------------------------------------------
//calage absolu
bool calage_a(FILE *f,char mot[len]);
//-----------------------------------------------------------------------
//test segment jointif gauche
bool segment_jointif_gauche(struct segment s1,struct segment s2);
//-----------------------------------------------------------------------
//test segment jointif droite
bool segment_jointif_droite(struct segment s1,struct segment s2);
//-----------------------------------------------------------------------
//distance entre deux points
double distance_d(struct point p1,struct point p2);
//-----------------------------------------------------------------------
//selection d'un segment libre
long recherche_segment_libre(struct segment *S,long n);
//-----------------------------------------------------------------------
//recherche segment jointif
long recherche_segment_jointif(struct segment *S,long n,struct segment s);
//-----------------------------------------------------------------------
//orientation gauche droite
struct segment orientation(struct segment s);
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
#endif
