/*
  File: main.cpp

  (C) 2011 Philbob

  This program is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 2.1 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
//-----------------------------------------------------------------------
//	main.cpp
//-----------------------------------------------------------------------
#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>
//-----------------------------------------------------------------------
#define classe_e 
#include<main.h>
#undef classe_e

#define classe_e extern
#include<commun.h>
#undef classe_e

#define classe_e extern
#include<specifique.h>
#undef classe_e

//-----------------------------------------------------------------------
using namespace std;
//-----------------------------------------------------------------------
int main(void)
{
	system("clear");
	
	init();

	debut();
		
	action();

	fin();
			
	return 0;
}
//-----------------------------------------------------------------------
//init
void init(void)
{
}
//-----------------------------------------------------------------------
//fonction action
void action(void)
{
	FILE *fs;
	FILE *f_cfg;	//en entree fichier de configuration de l'extraction
	FILE *f_txt;	//en entree fichier descriptif du tube
	FILE *f_dxf;	//en entree fichier "CAO" du reseau de courbes du tube
	FILE *f_dat;	//en sortie fichier du reseau de courbe du tube sous forme de liste
	FILE *f_gnu;	//en sortie fichier du reseau de courbe du tube sous forme de triplets Vg,Va,Ia pour gnuplot
	FILE *f_tdf;	//en sortie fichier du reseau de courbe du tube sous forme tdf
					//(voir  http://www.dissident-audio.com/index.html)
	
	char bidon[len];	//chaine "bidon" pour lecture dans les fichiers
	
	char chemin[len];	//chemin d'acces au répertoire de travail
	char tube[len];		//nom du tube
	
	char nom_txt[len];	//nom du fichier txt
	char nom_dxf[len];	//nom du fichier dxf
	char nom_dat[len];	//nom du fichier dat
	char nom_gnu[len];	//nom du fichier gnu
	char nom_tdf[len];	//nom du fichier tdf
	
	long ns;	//nombre de segments contenus dans f_dxf
	
	long i;		//indice de boucle
	long j;		//indice de boucle
	long k;		//indice de boucle
	long l;		//indice de boucle
	
	struct segment *seg;		//tableau de segments
	struct segment *segsel; 	//tableau des segments des courbes
	struct segment seg_deb;		//segment de début
	struct segment seg_cour;	//segment courant
	struct point **p;			//tableau des points de chaque courbe
	
	bool suite;	//variable de continuation
	bool ok;	//variable de continuation
	
	double xmin;
	double dist1;
	double dist2;
	long isel;
	long jsel;
	
	double ori_v,ext_v,ori_px,ext_px;
	double ori_i,ext_i,ori_py,ext_py;
	double Av,Bv;
	double Ai,Bi;
	double *v_grille;
	
	double P_max,V_max;
	
	double x,y;
	
	long nc;		//nombre de courbes
	long *npc;		//tableau du nombre de points par courbe
	long *npcc;		//tableau du nombre de points "non clippés" par courbe
	
	
	fs=stdout;
	
	//recherche du fichier à traiter, formation des noms de fichier
	
	//ouverture du fichier de config
	f_cfg=fopen("config.txt","r");
	verif(f_cfg,"ouverture du fichier config.txt impossible");

	//recup du chemin
	calage_a(f_cfg,"#chemin");
	
	fscanf(f_cfg,"%s",chemin);
	
	fprintf(fs,"chemin des donnees = %s\n",chemin);
	
	//recup du prefixe
	calage_a(f_cfg,"#tube");
	
	fscanf(f_cfg,"%s",tube);
	
	fprintf(fs,"tube = %s\n",tube);
	
	//formation des noms de fichier
	strcpy(nom_txt,chemin);
	strcat(nom_txt,tube);
	strcat(nom_txt,".txt");
	
	strcpy(nom_dxf,chemin);
	strcat(nom_dxf,tube);
	strcat(nom_dxf,".dxf");
	
	strcpy(nom_dat,chemin);
	strcat(nom_dat,tube);
	strcat(nom_dat,".dat");
	
	strcpy(nom_gnu,chemin);
	strcat(nom_gnu,tube);
	strcat(nom_gnu,".gnu");
	
	strcpy(nom_tdf,chemin);
	strcat(nom_tdf,tube);
	strcat(nom_tdf,".tdf");
	
	fprintf(fs,"fichier txt en entree = %s\n",nom_txt);
	fprintf(fs,"fichier dxf en entree = %s\n",nom_dxf);
	fprintf(fs,"fichier dat en sortie = %s\n",nom_dat);
	fprintf(fs,"fichier gnu en sortie = %s\n",nom_gnu);
	fprintf(fs,"fichier tdf en sortie = %s\n",nom_tdf);
	
	//ouverture du fichier txt
	f_txt=fopen(nom_txt,"r");
	verif(f_txt,"ouverture du fichier txt impossible");
	
	//ouverture du fichier dxf
	f_dxf=fopen(nom_dxf,"r");
	verif(f_dxf,"ouverture du fichier dxf impossible");
	
	//creation du fichier dat
	f_dat=fopen(nom_dat,"w");
	verif(f_dat,"creation du fichier dat impossible");
	
	//creation du fichier gnu
	f_gnu=fopen(nom_gnu,"w");
	verif(f_gnu,"creation du fichier gnu impossible");
	
	//creation du fichier tdf
	f_tdf=fopen(nom_tdf,"w");
	verif(f_tdf,"creation du fichier tdf impossible");
	
	//recup et calcul des echelles
	calage_a(f_txt,"#ori_V");
	fscanf(f_txt,"%lg",&ori_v);
	fscanf(f_txt,"%lg",&ori_px);
	
	calage_a(f_txt,"#ext_V");
	fscanf(f_txt,"%lg",&ext_v);
	fscanf(f_txt,"%lg",&ext_px);
	
	calage_a(f_txt,"#ori_I");
	fscanf(f_txt,"%lg",&ori_i);
	fscanf(f_txt,"%lg",&ori_py);
	
	calage_a(f_txt,"#ext_I");
	fscanf(f_txt,"%lg",&ext_i);
	fscanf(f_txt,"%lg",&ext_py);
	
	systeme_2D(ori_px,1,ext_px,1,ori_v,ext_v,Av,Bv);
	systeme_2D(ori_py,1,ext_py,1,ori_i,ext_i,Ai,Bi);
	
	//recup param max
	calage_a(f_txt,"#v_max");
	fscanf(f_txt,"%lg",&V_max);
	
	calage_a(f_txt,"#p_max");
	fscanf(f_txt,"%lg",&P_max);
	
	
	//extraction des points du reseau de courbe
	
	//extraction

	//determination du nombre de segments
	ns=0;
	
	calage_a(f_dxf,"reseau");
	
	do
	{
		if (calage_r(f_dxf,"reseau")==true)
		{
			calage_r(f_dxf,"ByLayer");
		
			ns++;
		}
	
	}
	while (feof(f_dxf)==0);
	
	fprintf(fs,"nombre de segments = %ld\n",ns);
	
	//resa memo segments
	seg=new struct segment[ns];
	verif(seg,"resa memo seg impossible");	
	
	segsel=new struct segment[ns];
	verif(segsel,"resa memo segsel impossible");	
	
	//chargement des segments
	calage_a(f_dxf,"reseau");
	
	for (i=0;i<ns;i++)
	{
		calage_r(f_dxf,"reseau");
		calage_r(f_dxf,"ByLayer");
		
		fscanf(f_dxf,"%s",&bidon);
		fscanf(f_dxf,"%lg",&x);
		
		fscanf(f_dxf,"%s",&bidon);
		fscanf(f_dxf,"%lg",&y);

		seg[i].pa.x=x*Av+Bv;		
		seg[i].pa.y=y*Ai+Bi;		
		
		
		fscanf(f_dxf,"%s",&bidon);
		fscanf(f_dxf,"%s",&bidon);

		fscanf(f_dxf,"%s",&bidon);
		fscanf(f_dxf,"%lg",&x);
		
		fscanf(f_dxf,"%s",&bidon);
		fscanf(f_dxf,"%lg",&y);

		seg[i].pb.x=x*Av+Bv;		
		seg[i].pb.y=y*Ai+Bi;		
		
		seg[i].sel=false;
	}
	
	//reorganisation et coutures des segments
	
	//orientation gauche droite
	for (i=0;i<ns;i++)
	{
		seg[i]=orientation(seg[i]);
	}
	
	ok=true;
	j=0;
	
	while (ok==true)
	{
		//recherche du premier segment dans les segments disponibles
		isel=-1;
		
		for (i=0;i<ns;i++)
		{ 	
			if (seg[i].sel==false)
			{
				isel=i;
			}
		}
		
		//test: y a t'il un segment non traité?
		if (isel<0)
		{
			//non: arret
			ok=false;
		}
		else
		{
			//oui: recherche du segment présentant le x mini
			xmin=seg[isel].pa.x;
	
			for (i=0;i<ns;i++)
			{
				if (seg[i].sel==false)
				{
					if (seg[i].pa.x<xmin)
					{
						xmin=seg[i].pa.x;
						isel=i;
					}

					if (seg[i].pb.x<xmin)
					{
						xmin=seg[i].pb.x;
						isel=i;
					}
				}
			}
			
			//marquage du segment comme utilisé
			seg[isel].sel=true;

			//mémorisation du segment
			segsel[j]=seg[isel];
			j++;	

			suite=true;
			
			//couture des segments par recherche d'un segment contigu
			while (suite==true)
			{
				//recherche du segment contigu à seg[isel]. si ok, alors jsel est l'indice du segment contigu
				jsel=recherche_segment_jointif(seg,ns,seg[isel]);
		
				//test existence d'un segment contigu
				if (jsel<0)
				{
					//non: arret
					suite=false;
				}
				else
				{
					//oui: marquage du segment comme utilisé
					isel=jsel;
					seg[isel].sel=true;
					
					//memorisation du segment
					segsel[j]=seg[isel];
					j++;	
				}
			}	
		}
	}
	
	//determination du nombre de courbes
	nc=1;

	for (i=1;i<ns;i++)
	{
		//test de rupture de continuité: si oui alors c'est une nouvelle courbe
		if (segment_jointif_droite(segsel[i-1],segsel[i])==false)
		{
			nc++;
		}
	}	
	
	fprintf(fs,"nombre de courbes = %ld\n",nc);
	
	//recup des tensions de grille
	v_grille=new double[nc];
	verif(v_grille,"resa memo v_grille impossible");
	
	npc=new long[nc];
	verif(npc,"resa memo npc impossible");
	
	npcc=new long[nc];
	verif(npcc,"resa memo npcc impossible");
	
	calage_a(f_txt,"#v_grille");
	
	for (i=0;i<nc;i++)
	{
		fscanf(f_txt,"%lg",&v_grille[i]);
		npc[i]=0;
		
		fprintf(fs,"tension de grille = %lg\n",v_grille[i]);
	}
	
	//determination du nombre de points par courbe
	j=0;
	
	for (i=1;i<ns;i++)
	{
		npc[j]++;
		
		//test si segments jointifs: si oui, incrément du nombre de point
		if (segment_jointif_droite(segsel[i-1],segsel[i])==false)
		{
			j++;
		}
	}
	
	//clip des points à Vamin et Iamin
	p=(struct point**)malloc(nc*sizeof(struct point*));
	verif(p,"resa memo primaire p impossible");
	
	l=0;

	//determination des points retenus et resa memo	
	for (i=0;i<nc;i++)
	{
		npcc[i]=0;
		
		for (j=0;j<npc[i];j++)
		{
			if (segsel[l].pa.x>=ori_v && segsel[l].pa.y>=ori_i)
			{
				npcc[i]++;
			}
			
			l++;
		}

		printf("nc %ld npc %ld npcc %ld\n",i,npc[i],npcc[i]);

		p[i]=(struct point*)malloc(npcc[i]*sizeof(struct point));
		verif(p[i],"resa memo secondaire p impossible");
	}

	//chargement des points retenus
	l=0;
	
	for (i=0;i<nc;i++)
	{
		k=0;
		
		for (j=0;j<npc[i];j++)
		{
			if (segsel[l].pa.x>=ori_v && segsel[l].pa.y>=ori_i)
			{
				p[i][k]=segsel[l].pa;
				k++;
			}
			
			l++;
		}
	}
	

	
	for (i=0;i<nc;i++)
	{
		fprintf(fs,"courbe %ld nombre de points = %ld\n",i,npcc[i]);
	}	
	
	//ecriture fichier dat et gnu
	fprintf(f_dat,"%s\n",tube);
	fprintf(f_dat,"%lg\n",V_max);
	fprintf(f_dat,"%lg\n",P_max);
	fprintf(f_dat,"%ld\n",nc);

	for (i=0;i<nc;i++)
	{
		fprintf(f_dat,"%lg\n",v_grille[i]);
	}
	
	for (i=0;i<nc;i++)
	{
		fprintf(f_dat,"%ld\n",npcc[i]);
		
		for (j=0;j<npcc[i];j++)
		{
			fprintf(f_dat,"%lg %lg\n",p[i][j].x,p[i][j].y);
			fprintf(f_gnu,"%lg %lg %lg\n",v_grille[i],p[i][j].x,p[i][j].y);
		}

		fprintf(f_gnu,"\n");
	}
	
	//ecriture fichier tdf
	for (i=nc-1;i>=0;i--)
	{
		fprintf(f_tdf,"%lg %lg %lg ? 0 ?%c\n",0.0,0.0,v_grille[i],13);

		for (j=0;j<npcc[i];j++)
		{
			fprintf(f_tdf,"%lg %lg %lg ? 0 ?%c\n",p[i][j].x,p[i][j].y/1000,v_grille[i],13);
		}
	}
	
			
	//fermetures

	fclose(f_cfg);
	fclose(f_txt);
	fclose(f_dxf);
	fclose(f_dat);
	fclose(f_gnu);
	fclose(f_tdf);


	delete [] seg;
	delete [] segsel;
	delete v_grille;
	delete npc;
	delete npcc;
	
	for (i=0;i<nc;i++)
	{
		free(p[i]);
	}
	
	free(p);
	
}
//-----------------------------------------------------------------------
