/*
  File: specifique.cpp

  (C) 2011 Philbob

  This program is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 2.1 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
//-----------------------------------------------------------------------
//	specifique.cpp
//-----------------------------------------------------------------------
#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>
#include<termios.h>
#include<fcntl.h>
#include<unistd.h>
//-----------------------------------------------------------------------
#define classe_e 
#include<specifique.h>
#undef classe_e

#define classe_e extern
#include<commun.h>
#undef classe_e

//-----------------------------------------------------------------------
using namespace std;
//-----------------------------------------------------------------------
//determinant
double determinant	(
						double l1c1,
						double l1c2,
						double l2c1,
						double l2c2
					)
{
	double res;
	
	res=l1c1*l2c2-l2c1*l1c2;
	
	return res;
}
//-----------------------------------------------------------------------
//resolution systeme 2 eq 2 inc
bool systeme_2D	(
						double l1c1,
						double l1c2,
						double l2c1,
						double l2c2,
						double sml1,
						double sml2,
						double &r1,
						double &r2
					)
{
	bool res;
	
	double dd,dr1,dr2;
	
	dd=determinant(l1c1,l1c2,l2c1,l2c2);
	
	if (dd!=0)
	{
		res=true;
		
		dr1=determinant(sml1,l1c2,sml2,l2c2);
		dr2=determinant(l1c1,sml1,l2c1,sml2);
		
		r1=dr1/dd;
		r2=dr2/dd;
	}
	else
	{
		res=false;
		
		r1=0;
		r2=0;
	}
	return res;
}
//-----------------------------------------------------------------------
//calage relatif
bool calage_r(FILE *f,char mot[len])
{
	bool res;
	char chaine[len];
	int lenc;	
	
	res=false;
	lenc=strlen(mot);
	
	do
	{
		fgets(chaine,len,f);
		
		if (strncmp(chaine,mot,lenc)==0)
		{
			res=true;
		}
	}
	while (feof(f)==0 && res==false);
	
	if (res==false)
	{
		printf("ATTENTION, mot clef %s introuvable\n",mot);
	}
	
	return res;
}
//-----------------------------------------------------------------------
//calage absolu
bool calage_a(FILE *f,char mot[len])
{
	bool res;

	rewind(f);
	
	res=calage_r(f,mot);
	
	return res;
}
//-----------------------------------------------------------------------
//test segment jointif gauche
bool segment_jointif_gauche(struct segment s1,struct segment s2)
{
	bool res;
	double dist;
	
	res=false;
	
	dist=distance_d(s1.pa,s2.pb);
	
	if (dist==0)
	{
		res=true;
	}
	
	return res;
}
//-----------------------------------------------------------------------
//test segment jointif droite
bool segment_jointif_droite(struct segment s1,struct segment s2)
{
	bool res;
	double dist;
	
	res=false;
	
	dist=distance_d(s1.pb,s2.pa);
	
	if (dist==0)
	{
		res=true;
	}
	
	return res;
}
//-----------------------------------------------------------------------
//distance entre deux points
double distance_d(struct point p1,struct point p2)
{
	double res;
	double dx;
	double dy;
	
	dx=p1.x-p2.x;
	dy=p1.y-p2.y;
	
	res=sqrt(dx*dx+dy*dy);
	
	return res;
}
//-----------------------------------------------------------------------
//selection d'un segment libre
long recherche_segment_libre(struct segment *S,long n)
{
	long res;
	bool suite;
	long i;
	
	suite=true;
	i=0;
	res=-1;
	
	while (suite && i<n)
	{
		if (S[i].sel==false)
		{
			res=i;
			suite=false;
		}
		
		i++;
	}
	
	return res;
}
//-----------------------------------------------------------------------
//recherche segment jointif
long recherche_segment_jointif(struct segment *S,long n,struct segment s)
{
	long res;
	bool suite;
	long i;
	
	suite=true;
	i=0;
	res=-1;
	
	while (suite==true)
	{
		if (S[i].sel==false)
		{
			if (segment_jointif_gauche(s,S[i])==true)
			{
				suite=false;
				res=i;
			}

			if (segment_jointif_droite(s,S[i])==true)
			{
				suite=false;
				res=i;
			}
		}

		i++;
			
		if (i>=n)
		{
			suite=false;
		}
	}
	
	return res;
}
//-----------------------------------------------------------------------
//orientation gauche droite
struct segment orientation(struct segment s)
{
	struct segment res;
	
	res=s;
	
	if (s.pa.x>s.pb.x)
	{
		res.pa=s.pb;
		res.pb=s.pa;
	}
	
	
	
	return res;
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
